#include "sdk/amxxmodule.h"

short g_pParachuteModel;
short g_pParachuteSound;
edict_t *g_pParachute[33];

cvar_t *sv_fallspeed;
cvar_t init_sv_fallspeed = {"sv_fallspeed", "100"};

void Parachute_Kill(edict_t *pEntity)
{
	int iPlayer = ENTINDEX(pEntity);
	if(ENTINDEX(g_pParachute[iPlayer]))
	{
		REMOVE_ENTITY(g_pParachute[iPlayer]);
	}
	g_pParachute[iPlayer] = NULL;
}

void ClientDisconnect(edict_t *pEntity)
{
	Parachute_Kill(pEntity);
	RETURN_META(MRES_IGNORED);
}

void ClientPutInServer(edict_t *pEntity)
{
	Parachute_Kill(pEntity);
	RETURN_META(MRES_IGNORED);
}

void PlayerPreThink(edict_t *pEntity)
{
	int iPlayer = ENTINDEX(pEntity);

	edict_t * pParachute = g_pParachute[iPlayer];
	int iParachute = ENTINDEX(pParachute);

	if((iParachute > 0) && (pEntity->v.flags & FL_ONGROUND))
	{
		if(pParachute->v.sequence != 2)
		{
			pParachute->v.sequence = 2;
			pParachute->v.gaitsequence = 1;
			pParachute->v.frame = 0.0;
			pParachute->v.fuser1 = 0.0;
			pParachute->v.animtime = 0.0;
			pParachute->v.framerate = 0.0;
			RETURN_META(MRES_IGNORED);
		}

		pParachute->v.frame = pParachute->v.fuser1 + 4.0;
		pParachute->v.fuser1 = pParachute->v.frame;

		if(pParachute->v.frame > 252.0)
		{
			Parachute_Kill(pEntity);
		}
		RETURN_META(MRES_IGNORED);
	}

	if(pEntity->v.button & IN_USE)
	{
		if(pEntity->v.velocity.z < -0.0)
		{
			if((iParachute <= 0) && (pEntity->v.flFallVelocity > 300.0))
			{
				g_pParachute[iPlayer] = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
				edict_t * pParachute = g_pParachute[iPlayer];
				int iParachute = ENTINDEX(pParachute);

				if(iParachute > 0)
				{
					pParachute->v.aiment = pEntity;
					pParachute->v.owner = pEntity;
					pParachute->v.movetype = MOVETYPE_FOLLOW;
					pParachute->v.classname = MAKE_STRING("parachute");
					//pParachute->v.model = MAKE_STRING("models/parachute.mdl");
					SET_MODEL(pParachute, "models/parachute.mdl");
					pParachute->v.sequence = 0;
					pParachute->v.gaitsequence = 1;
					pParachute->v.frame = 0.0;
					pParachute->v.fuser1 = 0.0;

					EMIT_AMBIENT_SOUND(pEntity, pEntity->v.origin, "parachute.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
				}
			}

			if(iParachute > 0)
			{
				float fallspeed = 0 - sv_fallspeed->value;
				float zvel = pEntity->v.velocity.z + 40.0;

				pEntity->v.sequence = 3;
				pEntity->v.gaitsequence = 1;
				pEntity->v.frame = 1.0;
				pEntity->v.fuser1 = 1.0;

				if(pParachute->v.sequence == 0)
				{
					pParachute->v.frame = pParachute->v.fuser1 + 2.0;
					pParachute->v.fuser1 = pParachute->v.frame;

					if(pParachute->v.frame > 100.0)
					{
						pParachute->v.animtime = 0.0;
						pParachute->v.framerate = 0.4;
						pParachute->v.sequence = 1;
						pParachute->v.gaitsequence = 1;
						pParachute->v.frame = 0.0;
						pParachute->v.fuser1 = 0.0;
					}
					else if(pParachute->v.frame > 25.0)
					{
						pEntity->v.velocity.z = (zvel < fallspeed) ? zvel : fallspeed;
					}
				}
				else
				{
					pEntity->v.velocity.z = (zvel < fallspeed) ? zvel : fallspeed;
				}
			}
		}
		else
		{
			Parachute_Kill(pEntity);
		}
		
	}
	else if((iParachute > 0) && (pEntity->v.oldbuttons & IN_USE))
	{
		Parachute_Kill(pEntity);
	}

	RETURN_META(MRES_IGNORED);
}

AMX_NATIVE_INFO natives_Exports[] = {
	  /////////////////// <--- 19 chars max in current small version
	{NULL,					NULL}
};

void OnPluginsLoaded()
{
	g_pParachuteModel = PRECACHE_MODEL("models/parachute.mdl");
	g_pParachuteSound = PRECACHE_SOUND("parachute.wav");

	CVAR_REGISTER(&init_sv_fallspeed);
	sv_fallspeed = CVAR_GET_POINTER(init_sv_fallspeed.name);
}
